<?php
/************************************************
 *
 *              dbfMySQL
 *
 *  originally written by: Miguel Feitosa 
 *   for Vamonessa Venture Partners
 *
 *  updated by: Leonard den Ottolander (2002,2003)
 *
 *  Package to assist porting 
 *   dbf files to MySQL tables
 *  For this modification you need the PHP
 *   patch that provides the functions
 *    - dbase_field_names
 *    - dbase_field_types
 *    - dbase_field_lengths
 *    - dbase_field_decimals
 *    also by Leonard den Ottolander (2002)
 *
 *  This version of the software is GPL.
 *  The original package is in the public domain.
 *  Use at your own risk.
 *   
 *  old contact: mfeitosa@vamonessa.com.br
 *           http://www.vamonessa.com.br
 *  contact: leonardjo@hetnet.nl
 *
 *************************************************/
  include("var.php3");
?>

<html>
  <?php print($css); ?>
  <body>
    <form method="GET" action="<?php p("$URL/import.php3"); ?>" >
      <table>
        <tr>
          <td>DBase file name:</td>
          <td><input type="text" name="file_name" size="40" value="<?php p($file_name)?>" ></td>
        </tr>
        <tr>
          <td>MySQL table name:</td>
          <td><input type="text" name="table_name" size="40" value="<?php p($table_name)?>" ></td>
        </tr>
        <tr>
          <td>MySQL database:</td>
          <td><input type="text" name="db" size="40" value="<?php p($db); ?>" ></td>
        </tr>
        <tr>
          <td>MySQL user:</td>
          <td><input type="text" name="db_user"  size="40" value="<?php p($db_user); ?>" ></td>
        </tr>
        <tr>
          <td>MySQL password:</td>
          <td><input type="password"  name="db_pass"  size="40" value="<?php p($db_pass); ?>" ></td>
        </tr>
        <tr>
          <td>MySQL host:</td>
          <td><input type="text" name="db_host"   size="40" value="<?php p($db_host); ?>" ></td>
        </tr>
      </table>
  
<?php
  $h = dbase_open($file_name, 0);

  if($h==FALSE)
  {
    print "$file_name cannot be open for reading";
    exit();
  }
  $record = dbase_get_record_with_names ($h, 1);
  $fieldnames = array_keys($record);

  while (list ($nada, $fieldname) = each ($fieldnames))
  {
    $destnames = "did[".$fieldname."]";
    $val = $did[$fieldname];
    echo(" <input type=\"hidden\"  name=\"$destnames\" value=\"$val\" >\n ");
  }
  reset($fieldnames);
?>


      <input type="submit" value="Import Data" name="runquery" >
    </form>

<?php
  if(!isset($file_name))
  {
?>

<BR>
  </body>
</html>

<?php
    exit();
  }
?>


<?php
  set_time_limit (0);
  ignore_user_abort (3);
  include("connect.php3");

  if(isset($err_log))
  {
    print "Could not connect MySQL";
    exit();
  }

  $h = dbase_open($file_name, 0);

  if($h==FALSE)
  { 
    print "$file_name cannot be open for reading";
    exit();
  }
  else
  {
    $num = dbase_numrecords ($h);
/*
    $last_dot = strrpos ($file_name, ".");
    if (is_string ($last_dot) && !$last_dot)
    {
         // not found...
    }
    else
    {
      $file_name = substr($file_name, 0 , $last_dot);
    }
    $last_slash = strrpos($file_name,"/");            
    if (is_string ($last_slash) && !$last_slash)
    {
           // not found...
    }
    else
    {
      $file_name = substr($file_name, $last_slash+1);
    }
*/
    echo("<pre>");

    $start = time();
    for($i=1 ; $i <= $num ; $i++)
    {
      flush();
      echo(" $i\t");
      if($i%20==0) echo("\n");
      $record =  dbase_get_record_with_names ($h, $i);
      $fieldnames = array_keys($record);
      $q = " INSERT into $table_name (   ";
      $flag = 0;
      reset($fieldnames);
      while (list ($nada, $fieldname) = each ($fieldnames))
      {
        if($fieldname=="deleted") continue;
        $t = $did[$fieldname];
        $q .= " $t";
        if(next($fieldnames)!=FALSE)
        {
          $q.= ","; prev($fieldnames);
        }
      } 
   
      $q .= ") VALUES ( ";
   
      reset($fieldnames);
      while (list ($nada, $fieldname) = each ($fieldnames))
      {
        $temp = addslashes($record[$fieldname]);
        $temp=trim($temp);
        $q .= " '$temp' ";
        if(next($fieldnames)!=FALSE)
        {
          $q.= ","; prev($fieldnames);
        }
      } 
      $q .= ")";

      $qry_res =  mysql_query ($q, $DatabaseLink);
      if(mysql_affected_rows($DatabaseLink)!=1)
      {
        if($flag==0)
        {
          $flag=1;echo("$q");
        }
        echo("\n<br>Error: Unable to insert $i");
        echo("\n<br>File: $file_name");
	print("<br>mysql insert query failed ". 
         mysql_errno() . ": " . 
	 mysql_error() ."<br>\n");


        exit();
      }
      else
      {
        $the_record =  mysql_insert_id ($DatabaseLink);
        $q = " SELECT * from $table_name where id=$the_record ";
        $qry_res =  mysql_query ($q, $DatabaseLink);
        $the_record = mysql_fetch_array ($qry_res);
        reset($fieldnames);
	$fieldtypes = dbase_field_types($h);
	$j = 0;
        while(  list ($nada, $fieldname1) = each ($fieldnames))
        {
          $fieldname2 = $did[$fieldname1];

          if($fieldname1!="deleted")
	  {
	    switch ($fieldtypes[$j])
	    { 
	      case "N":
	      case "D":
	        break;
	      default:
                if ( strcmp(trim($record[$fieldname1]),trim($the_record[$fieldname2]))!=0 )
                {
                  if($flag==0)
	          {
  	            $flag=1;echo("$q");
                  }
                  echo("\n<br>Error: Field $fieldname2  ($record[$fieldname1],$the_record[$fieldname2])  ");
                  echo("\n<br>File: $file_name");
                  exit();
	        }
            }
	  }
	  $j++;
        }
      }

    }
  }


  echo("\n$num records in dbase file.");
  $q = " SELECT max(id) from $table_name ";
  $qry_res =  mysql_query ($q, $DatabaseLink);
  $the_record = mysql_fetch_array ($qry_res);
  $the_record = $the_record[0];
  echo("\nmax(id) is ".$the_record." in mysql table $db.$table_name.\n");
  $finish = time()-$start;
  if($finish<60)
  {
    echo ("Run complete in  $finish sec.");
    return;
  }
  $finish = $finish/60;
  if($finish > 60)
  {
    $finish = $finish/60; $finish=$finish." hours";
  }
  else
  { $finish=$finish." minutes";
  }
  echo ("Run complete in  $finish.");

?>
    </pre>
  </body>
</html>
