<?php
/************************************************
 *
 *              dbfMySQL
 *
 *  originally written by: Miguel Feitosa 
 *   for Vamonessa Venture Partners
 *
 *  updated by: Leonard den Ottolander (2002,2003)
 *
 *  Package to assist porting 
 *   dbf files to MySQL tables
 *  For this modification you need the PHP
 *   patch that provides the functions
 *    - dbase_field_names
 *    - dbase_field_types
 *    - dbase_field_lengths
 *    - dbase_field_decimals
 *    also by Leonard den Ottolander (2002)
 *
 *  This version of the software is GPL.
 *  The original package is in the public domain.
 *  Use at your own risk.
 *   
 *  old contact: mfeitosa@vamonessa.com.br
 *           http://www.vamonessa.com.br
 *  contact: leonardjo@hetnet.nl
 *
 *************************************************/
  include("var.php3");

  if(!isset($dbf_dir)||!isset($dbf_name))
  {
?>

<html>
  <?php print($css); ?>
  <body>
    <form method="POST" action="<?php echo "$URL/index.php3" ?>" >
      Full directory path containg the DBF database files: <BR>
      <input type="text" name="dbf_dir" value="<?php print $dbf_dir ?>">
      <BR>  Extension of DBF files: (such as DBF or dbf ): <BR>
      <input type="text" name="dbf_name" value="<?php print $dbf_name ?>" > <BR>
      <input type="submit" name="Open" value="Open" >
    </form>
  </body>
</html>

<?php
  exit();
  }
?>

<html>
  <?php print($css); ?>
  <body>

<?php

  if($dbf_dir[strlen($dbf_dir)-1]!="/") $dbf_dir.="/";

  $d = opendir($dbf_dir);

  while(($entry=readdir($d)))
  {
 
    if(!strstr ($entry, $dbf_name))
    { ;
    }
    else
    {
      $h=FALSE;
      if( is_file ($dbf_dir.$entry))
      {
        $h = dbase_open($dbf_dir.$entry, 0);
      }
  
      if(!$h)
      {
        $error[] = $entry;
      }
      else
      {
        $num =  dbase_numrecords($h) ;
        $records[$entry]=$num;
      }
    }
  }

  closedir($d);
  if(sizeof($records)<1) { print "No files found"; exit();}
  asort ($records);
  $oldval = -1;
  echo("Found ");
  echo(sizeof($records));
  echo(" $dbf_name tables.");
  echo("<BR>");

  reset($records);
  while (list ($key, $val) = each ($records))
  {
    $say = urlencode($dbf_dir.$key);
    $key = "<a href=\"show.php3?file_name=$say\"> $key </a>";
    $lastval = $val;
    if($val>$oldval)
    {
      if($oldval!=-1)
      {
        print "<BR>\n";
        print "Found $subtot tables with $oldval rows <BR>\n ";
        print "Searched $tot tables<BR>\n ";
      }
      $oldval = $val;
      print "<BR>\n";
      echo $val;
      print "--------------------------\n<BR>";
      print "<BR>\n";
      print"$key";
      $tot++;
      $subtot = 1;
    }
    else
    {
      print " $key ";
      $tot++;
      $subtot ++;
    }
  }

  print "<BR>Found $subtot tables with $lastval rows <BR>\n ";
  print "Searched $tot tables<BR>\n ";

  if(sizeof($error)>1)
  {
    print "<BR>Errors opening:<BR>";
    dump_array($error);
  }
?>
  </body>
</html>
