<?php
/************************************************
 *
 *              dbfMySQL
 *
 *  originally written by: Miguel Feitosa 
 *   for Vamonessa Venture Partners
 *
 *  updated by: Leonard den Ottolander (2002,2003)
 *
 *  Package to assist porting 
 *   dbf files to MySQL tables
 *  For this modification you need the PHP
 *   patch that provides the functions
 *    - dbase_field_names
 *    - dbase_field_types
 *    - dbase_field_lengths
 *    - dbase_field_decimals
 *    also by Leonard den Ottolander (2002)
 *
 *  This version of the software is GPL.
 *  The original package is in the public domain.
 *  Use at your own risk.
 *   
 *  old contact: mfeitosa@vamonessa.com.br
 *           http://www.vamonessa.com.br
 *  contact: leonardjo@hetnet.nl
 *
 *************************************************/
include("var.php3");
?>
<html>
<?php print($css); ?>
<body>

<?php
set_time_limit (0);

if(isset($create))
{
	$DatabaseLink = mysql_connect($db_host, $db_user,$db_pass);
	if(!$DatabaseLink)
	{
		print("<br>mysql_pconnect ". 
			mysql_errno() . ": " . 
			mysql_error() ."<br>\n");
		print("<br>Cannot connect to MySQL");
		exit();
        }
	if(!(mysql_select_db($db, $DatabaseLink)))
	{
	      print("<br>mysql_select_db " . 
			mysql_errno() . ": " . 
			mysql_error() . "<br>\n");
	      print("<br>Cannot open $db");
	}
	$rez = mysql_query ($query1,$DatabaseLink);
	      print("<br>mysql_query 1 " . 
			mysql_errno() . ": " . 
			mysql_error() . "<br>\n");
        $rez2 =  mysql_query ($query2,$DatabaseLink);
	      print("<br>mysql_query 2 " . 
			mysql_errno() . ": " . 
			mysql_error() . "<br>\n");
        if($rez2) { print "Created Table Succesfully";
?>

<form method="GET" action="<?php p("$URL/import.php3"); ?>" >
<table>
  <tr>
    <td>DBase file name:</td>
    <td><input type="text" name="file_name" size="40" value="<?php p($file_name)?>" ></td>
  </tr>
  <tr>
    <td>MySQL table name:</td>
    <td><input type="text" name="table_name" size="40" value="<?php p($table_name)?>" ></td>
  </tr>
  <tr>
    <td>MySQL database:</td>
    <td><input type="text" name="db" size="40" value="<?php p($db); ?>" ></td>
  </tr>
  <tr>
    <td>MySQL user:</td>
    <td><input type="text" name="db_user"  size="40" value="<?php p($db_user); ?>" ></td>
  </tr>
  <tr>
    <td>MySQL password:</td>
    <td><input type="password"  name="db_pass"  size="40" value="<?php p($db_pass); ?>" ></td>
  </tr>
  <tr>
    <td>MySQL host:</td>
    <td><input type="text" name="db_host"   size="40" value="<?php p($db_host); ?>" ></td>
  </tr>
</table>

<?php
$h = dbase_open($file_name, 0);

if($h==FALSE)
{ print "$file_name cannot be open for reading";
  exit();
}
  $record =  dbase_get_record_with_names ($h, 1);
  $fieldnames = array_keys($record);
  
  while (list ($nada, $fieldname) = each ($fieldnames))
  {
    $destnames = "did[".$fieldname."]";
    $val = $did[$fieldname];
    echo(" <input type=\"hidden\"  name=\"$destnames\" value=\"$val\" >\n ");
  }
reset($fieldnames);
?>

    <input type="submit" value="Import Data" name="runquery" >
</form>

<?php
} 
else /* !isset($create) */
{
	print "Error creating table for $file_name.";}
?>

</body></html>

<?php
	exit();
}
?>




<?php
/*$old_file_name = $file_name; */
$h = dbase_open($file_name, 0);

if($h==FALSE)
{ print "$file_name cannot be open for reading";
  exit();
}
else
{ $num = dbase_numrecords ($h);

  if($num<1) { 
    print "$file_name has no records.";
    exit();
  }

  $record =  dbase_get_record_with_names ($h, 1);
  $fieldnames = array_keys($record);
/*
  $last_dot = strrpos ($file_name, ".");
  if (is_string ($last_dot) && !$last_dot) {
         // not found...
  } else {
     $file_name = substr($file_name, 0 , $last_dot);
   }
  $last_slash = strrpos($file_name,"/");            
  if (is_string ($last_slash) && !$last_slash) {
         // not found...
  } else {
    $file_name = substr($file_name, $last_slash+1);
  }
*/
?>


<TABLE>
<TR>
<TD>

Table Schema for <?php p($file_name); ?><BR>
<form method="GET" action="<?php p("$URL/schema.php3"); ?>" >
  <input type="hidden" name="create" value="Y" >
  <input type="hidden" name="file_name" value="<?php p($file_name)?>" >
<table>
<!--  <tr>
    <td>DBase file name:</td>
    <td><input type="text" name="file_name" size="40" value="<?php p($file_name)?>" ></td>
  </tr>
-->
  <tr>
    <td>MySQL table name:</td>
    <td><input type="text" name="table_name" size="40" value="<?php p($table_name)?>" ></td>
  </tr>
  <tr>
    <td>MySQL database:</td>
    <td><input type="text" name="db" size="40" value="<?php p($DB); ?>" ></td>
  </tr>
  <tr>
    <td>MySQL user:</td>
    <td><input type="text" name="db_user"  size="40" value="<?php p($DB_user); ?>" ></td>
  </tr>
  <tr>
    <td>MySQL password:</td>
    <td><input type="password"  name="db_pass"  size="40" value="<?php p($DB_pass); ?>" ></td>
  </tr>
  <tr>
    <td>MySQL host:</td>
    <td><input type="text" name="db_host"   size="40" value="<?php p($DB_host); ?>" ></td>
  </tr>
</table>

<?php
  
  while (list ($nada, $fieldname) = each ($fieldnames))
  {
    $destnames = "did[".$fieldname."]";
    $val = $did[$fieldname];
    echo(" <input type=\"hidden\"  name=\"$destnames\" value=\"$val\" >\n ");
  }
/*  $record =  dbase_get_record_with_names ($h, 1);*/
/*  $fieldnames = array_keys($record);*/
reset($fieldnames);
?>

  <input type="submit" value="Run Query" name="runquery" ><BR>
Query 1:<br>
<textarea name="query1" cols="50" rows="1" > DROP TABLE IF EXISTS <?php p($table_name) ?></textarea>

</TD>
<TD>
Query 2:<br>
<textarea name="query2" cols="50" rows="30" > 
  CREATE TABLE  <?php p($table_name) ?> (
<?php 
  while (list ($nada, $fieldname) = each ($fieldnames))
  {
/*echo $did[($fieldname)];*/
    if($fieldname=="deleted") continue;
/*    echo ("   ".$fieldname." ".$$fieldname." $NOT_NULL, \n"); */
    echo ("   ".$did[($fieldname)]." ".$$fieldname." $NOT_NULL, \n");
  } 
  echo "    $MODIFIED TIMESTAMP $NOT_NULL, \n";
  echo "    $id int($tam) AUTO_INCREMENT PRIMARY KEY"; 

  if(is_array($mig))
  { 
    echo(",");
    echo("\n");
    reset($mig);
    $uel = each ($mig);
    while ($uel)
    {
      list ($ind_name, $is_Y) = $uel;
      if(strstr ($ind_name,"deleted")) continue;
/*      echo (" INDEX $ind_name") ;*/
      $destname = $did[$ind_name];
      echo (" INDEX index_$destname($destname)") ;
      if($uel=each($mig)) echo(",\n");   
    } 
  }
  else
  { /* single value also needs indexing
  */
  }
  echo("\n");
  echo")\n";

  dbase_close($h);  
}
 
?>

</textarea></form>

</TD>
</TR>
</TABLE>
</body>    </html>
